Subject: Re: [PATCH] pciaer: report config read/write errors

From: Stephen Hemminger <[email-masked]>
Date: Tue, 2 Dec 2008 11:44:41 -0800

On Tue, 02 Dec 2008 14:04:15 -0500
Loic Prylli <[email-masked]> wrote:

> On 12/02/2008 12:23 PM, Stephen Hemminger wrote:
> > This patch does more error checking in the Advanced Error Reporting code.
> > Since AER needs to access PCI registers > 255, it won't work without MMCONFIG
> > and other quirks may stop it as well. The code must check this by looking
> > at return values from pci_read/write_config_XXX calls.  
> >
> > I don't have any hardware that uses AER routines but discovered this 
> > in earlier versions of the sky2 driver that tried to use
> > pci AER routines. Ended up just giving up and using other ways to access PCI
> > config space on sky2 since there were too many platform glitches.
> >   
> 
> 
> 
> 
> When experimenting with sky2 driver, was pci_find_ext_capability() 
> returning non-zero although further ext-space accesses were failing?
> 

No pci_find_ext_capability would succeed but all access to registers >= 256
would fail if MMCONFIG failed. Since the device often asserts stray errors on boot, if the
error could not be cleared, the driver would get stuck when IRQ was enabled.

P.s: you can look back into LKML for Linus discussion about why MMCONFIG
is broken anyway.